        .386
        .model  flat, stdcall
        option  casemap:none
;
include \masm32\include\windows.inc			; I used v. 1.13
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\gdi32.inc
;
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\gdi32.lib
;
About           proto :DWORD, :DWORD, :DWORD, :DWORD
AlignCmd        proto :DWORD, :WORD
BoldCmd         proto
ChooseFonts     proto :HWND
ItalicCmd       proto
SaveCallback    proto :DWORD, :DWORD, :DWORD, :DWORD
SaveTheFile     proto :WORD
ToggleButton    proto :DWORD, :DWORD, :DWORD
UnderlineCmd    proto
WinMain         proto :DWORD,:DWORD,:DWORD,:DWORD
;
RGB     macro   red, green, blue
        xor     eax, eax
        mov     ah, blue
        shl     eax, 8
        mov     ah, green
        mov     al, red
        endm
;
HIWORD  macro   bigword  
        mov     eax, bigword
        and     eax, 0FFFF0000h         ;; Set to high word 
        shr     eax, 16
        endm
;
LOWORD  macro   bigword  
        mov     eax, bigword
        and     eax, 0FFFFh     	     ;; Set to low word 
endm
;
.const
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
NUM_POINTS      equ 16
;IDM_NEW        equ 100
IDM_BOLD        equ 100
IDM_ITALIC      equ 101
IDM_SAVE        equ 102
IDM_UNDERLINE   equ 102
IDM_SELECT      equ 107
IDM_UNDO        equ 108
IDM_ALIGNLEFT   equ 40005
IDM_ALIGNCENTER equ 40007
IDM_ALIGNRIGHT  equ 40008
IDM_SAVETXT     equ 40011
IDM_SAVERTF     equ 40012
IDM_CHOOSEFONT  equ 40014
IDM_ABOUT       equ 200
IDM_EXIT        equ 300
RICHED_ICON     equ 300
IDB_TOOLBAR     equ 400
ID_TOOLBAR      equ 1000
ID_RICHED       equ 1001
ID_CANCEL       equ 1002
ID_DOIT         equ 1003
CF_NOSCRIPTSEL  equ 000800000h
HFILE_ERROR     equ -1
;
.data
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
cf              CHOOSEFONT  <>
cfm             CHARFORMAT2 <>
pf              PARAFORMAT  <>
lpToolInfo      TOOLINFO    <>
myLogFont       LOGFONT     <>
;
ClassName       db  "SimpleWinClass", 0
AppName         db  "RichEdit", 0
MenuName        db  "RICHEDMENU", 0
szAboutBox      db  "AboutBox", 0
hToolBar        HWND    0
hRTFLib         DWORD   0
nTextChanged    DWORD   0
bItalic         DWORD   0
bBold           DWORD   0
bUnderLine      DWORD   0
szRichEdit      db  "RICHEDIT20A", 0    ; Version 2.0 or 3.0
; szRichEdit    db  "RICHEDIT", 0       ; Version 1.0
ReDLL           db  "RICHED20.DLL", 0   ; Version 2.0 or 3.0
; ReDLL         db  "RICHED32.DLL", 0   ; Version 1.0
;
tb      TBBUTTON < 0, IDM_BOLD, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON < 1, IDM_ITALIC, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON < 2, IDM_UNDERLINE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON < 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0>
        TBBUTTON < 3, IDM_ALIGNLEFT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON < 4, IDM_ALIGNCENTER, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
        TBBUTTON < 5, IDM_ALIGNRIGHT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0>
;
szTipBold       db  'Bold', 0
szTipItalic     db  'Italic', 0
szTipUnderline  db  'Underline', 0
szTipAlLeft     db  'Alignleft', 0
szTipAlCenter   db  'Aligncenter', 0
szTipAlRight    db  'Alignright', 0
;
; szFormat      db  "%d", 0
szTextFile      db  "Textdoc.txt", 0
szRtfFile       db  "Txtdoc.rtf", 0
szTxtFile       db  "Txtdoc.txt", 0
szFileName      db  28 DUP (0)
szMsgBuff       db  128 DUP (0)
szCreateWndowEx db  "Error creating RichEdit!", 0
szSetCharFormat db  "Error in SetCharFormat.", 0
szAlign         db  "Error in EM_SETMODIFY.", 0
szSetCharSize   db  "Error in SetCharSize.", 0
szSaveFile      db  "Error is save File.", 0
szAlignment     db  "Error in EM_SETPARAFORMAT.", 0
szLoadRTFLib    db  "Error loading DLL!", 0
szCreateToolbar db  "Error creating Toolbar!", 0
szCopyFailed    db  "Copy failed!", 0
szChooseFont    db  "Error or Canceled!", 0
szEM_GTCHRFRMAT db  "EM_GETCHARFORMAT failed!", 0
szProcName      db  "CreateFontIndirect.", 0
szNoUndo        db  "UNDO not possible!", 0
szSave          db  "Text not saved!", 0
;
.data?
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
nLastError      DWORD   ?
hInstance       HINSTANCE ?
CommandLine     LPSTR   ?
hMenu           HMENU   ?
lastError       DWORD   ?
hDc             HDC     ?
hToolTips       DWORD   ?
hFont           DWORD   ?
nTLY            DWORD   ?
nHeight         DWORD   ?
nLength         DWORD   ?
hBitMap         DWORD   ? 
hWndRichEdit    HWND    ?
hWndGlobal      HWND    ?
hRichEditGlobal HWND    ?
;
;
.code
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	invoke LoadLibrary, ADDR ReDLL
	.if eax == NULL
		invoke GetLastError
		mov nLastError,eax
		invoke FormatMessage,\
			FORMAT_MESSAGE_FROM_SYSTEM,\
			NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
		invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szLoadRTFLib,\
			MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
	.else
		mov hRTFLib, eax
	.endif
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,4
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,0
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,30,\
           30,400,300,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL rect:RECT
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL iSelect:DWORD
	;LOCAL hWndRichEdit:DWORD
	
	
	.IF uMsg==WM_DESTROY
		;invoke FreeLibrary, hRTFLib
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		push hWnd
		pop hWndGlobal
		invoke InitCommonControls
		invoke LoadBitmap,hInstance, 400
		mov hBitMap,eax
		invoke CreateToolbarEx, \
			hWnd, WS_CHILD or WS_BORDER or WS_VISIBLE or TBSTYLE_TOOLTIPS, \
			IDB_TOOLBAR, 6, NULL, hBitMap, ADDR tb, \
			7, 16, 16, 16, 16, size TBBUTTON
		.if eax == NULL
			invoke GetLastError
			mov nLastError,eax
			invoke FormatMessage,\
				FORMAT_MESSAGE_FROM_SYSTEM,\
				NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
			invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szCreateToolbar,\
				MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		.else
			mov hToolBar, eax
		.endif

		invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR szRichEdit, NULL,\
			WS_CHILDWINDOW or WS_VISIBLE or ES_MULTILINE or ES_SUNKEN or\
			ES_SAVESEL or WS_VSCROLL or\
			ES_AUTOVSCROLL or ES_NOHIDESEL, 0,0,0,0,\
			hWnd, ID_RICHED, hInstance, NULL
		.if eax == NULL
			invoke GetLastError
			mov nLastError,eax
			invoke FormatMessage,\
				FORMAT_MESSAGE_FROM_SYSTEM,\
				NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
			invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szCreateWndowEx,\
				MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		.else
			mov hWndRichEdit, eax
			mov hRichEditGlobal, eax
		.endif

		invoke GetDC, hWndRichEdit
		mov hDc, eax

		;set the initial font
		invoke GetStockObject, DEVICE_DEFAULT_FONT 
		invoke GetObject, eax, sizeof myLogFont, ADDR myLogFont
		invoke CreateFontIndirect, ADDR myLogFont
		invoke SelectObject, hDc, eax

		invoke ReleaseDC, hWndRichEdit, hDc

		;invoke ToggleButton, hWnd, IDM_BOLD, FALSE
		;mov bBold, eax
		
		;set the margins in pixels (low word is the left margin)
		mov ax, 10
		shl eax, 16
		mov ax, 10
		invoke SendMessage, hWndRichEdit,EM_SETMARGINS,\
			EC_LEFTMARGIN or EC_RIGHTMARGIN, eax

		;enable the notification in WM_COMMAND if text changed
		invoke SendMessage, hWndRichEdit,EM_SETEVENTMASK,\
			NULL, ENM_CHANGE

		xor eax, eax

	.ELSEIF uMsg==WM_NOTIFY
		mov ebx,[lParam]
		.IF dword ptr [ebx+8] == TTN_NEEDTEXT
			mov eax,dword ptr [ebx+4]
			.IF eax==IDM_BOLD
				mov dword ptr [ebx+12], offset szTipBold
			.ELSEIF eax==IDM_ITALIC
				mov dword ptr [ebx+12], offset szTipItalic
			.ELSEIF eax==IDM_UNDERLINE
				mov dword ptr [ebx+12], offset szTipUnderline
			.ELSEIF eax==IDM_ALIGNLEFT
				mov dword ptr [ebx+12], offset szTipAlLeft
			.ELSEIF eax==IDM_ALIGNCENTER
				mov dword ptr [ebx+12], offset szTipAlCenter
			.ELSEIF eax==IDM_ALIGNRIGHT
				mov dword ptr [ebx+12], offset szTipAlRight
			.ENDIF
		.ENDIF

	.ELSEIF uMsg==WM_COMMAND
		mov eax, wParam
		HIWORD eax
		;notification that the text has changed
		.if ax==EN_CHANGE
			mov nTextChanged, 1
		.endif

		;other notifications from menus
		mov eax,wParam
		.IF ax==IDM_EXIT
			.if nTextChanged == TRUE
				invoke MessageBoxEx, NULL, ADDR szSave, NULL,\
					MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
			.endif
			invoke DestroyWindow,hWnd
		.ELSEIF ax==IDM_SAVETXT
			invoke SaveTheFile, ax
		.ELSEIF ax==IDM_SAVERTF
			invoke SaveTheFile, ax
		.ELSEIF ax==IDM_BOLD
                	invoke BoldCmd
	                invoke ToggleButton, hWnd, IDM_BOLD, bBold
			mov bBold, eax
		.ELSEIF ax==IDM_ITALIC 
                	invoke ItalicCmd
	                invoke ToggleButton, hWnd, IDM_ITALIC, bItalic
			mov bItalic, eax
		.ELSEIF ax==IDM_UNDERLINE 
                	invoke UnderlineCmd
	                invoke ToggleButton, hWnd, IDM_UNDERLINE, bUnderLine
			mov bUnderLine, eax
		.ELSEIF ax==IDM_ALIGNRIGHT
			invoke AlignCmd, hWnd, ax
		.ELSEIF ax==IDM_ALIGNLEFT
			invoke AlignCmd, hWnd,  ax
		.ELSEIF ax==IDM_ALIGNCENTER
			invoke AlignCmd, hWnd, ax
		.ELSEIF ax==IDM_SELECT
			invoke SendMessage, hWndRichEdit, EM_SETSEL, 0, 0FFFFFFFFh
		.ELSEIF ax==IDM_UNDO
			invoke SendMessage, hWndRichEdit, EM_CANUNDO, 0, 0
			.if eax == TRUE
				invoke SendMessage, hWndRichEdit, EM_UNDO, 0, 0
			.else
				invoke MessageBoxEx, NULL, ADDR szNoUndo, NULL,\
					MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
			.endif
		.ELSEIF ax==IDM_CHOOSEFONT
			invoke ChooseFonts, hWnd						
		.ELSEIF ax==IDM_ABOUT
			invoke CreateDialogParam, hInstance, ADDR szAboutBox, hWnd, offset About, NULL
 		.ENDIF

	.ELSEIF uMsg==WM_CLOSE
		.if nTextChanged == TRUE
			invoke MessageBoxEx, NULL, ADDR szSave, NULL,\
				MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		.endif
		invoke DestroyWindow,hWnd

	.ELSEIF uMsg==WM_SIZE

            	; Tell the toolbar to resize itself to fill the top of the window.
	        invoke SendMessage, hToolBar, TB_AUTOSIZE, 0, 0
        	; Get the size of the toolbar
	        invoke GetWindowRect, hToolBar, ADDR rect
        	; Size the rich edit control to fit in the client below the toolbar
		mov eax, rect.bottom
		sub eax, rect.top	
		mov nTLY, eax
		HIWORD lParam
		mov nHeight, eax
		LOWORD lParam
		mov nLength, eax
            	invoke MoveWindow, hWndRichEdit, 0, nTLY, nLength, nHeight, TRUE 

	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp

ToggleButton proc hWnd:HWND, nID:DWORD, bToggle:DWORD
    .if bToggle == TRUE
    	;Uncheck the menu item and unpress the toolbar button.
	invoke GetMenu, hWnd
        invoke CheckMenuItem, eax, nID, (MF_BYCOMMAND or MF_UNCHECKED)
        invoke SendMessage, hToolBar, TB_CHECKBUTTON, nID, FALSE
	mov eax, FALSE
        ret
    .else
    	;Check the menu item and press the toolbar button.
	invoke GetMenu, hWnd
        invoke CheckMenuItem, eax, nID, (MF_BYCOMMAND or MF_CHECKED)
        invoke SendMessage, hToolBar, TB_CHECKBUTTON, nID, TRUE
	mov eax, TRUE
	ret
    .endif
ToggleButton endp

BoldCmd proc

	;Fill out the CHARFORMAT structure to set character effects.
	mov cfm.cbSize, sizeof cfm
	mov cfm.dwMask, (CFM_BOLD or CFM_FACE)

	mov cfm.cbSize,60

	;Get the bold status.
	invoke SendMessage, hRichEditGlobal, EM_GETCHARFORMAT, TRUE, ADDR cfm

	;Toggle the bold effect
	xor cfm.dwEffects, CFE_BOLD

	;Set the new bold status.
	invoke SendMessage, hRichEditGlobal, EM_SETCHARFORMAT, SCF_SELECTION, ADDR cfm
	.if eax == NULL
		invoke GetLastError
		mov nLastError,eax
		invoke FormatMessage,\
			FORMAT_MESSAGE_FROM_SYSTEM,\
			NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
		invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szAlignment,\
			MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
	.endif
	xor eax, eax
	ret
BoldCmd endp

ItalicCmd proc

	;Fill out the CHARFORMAT structure to set character effects.
	mov cfm.cbSize, sizeof cfm
	mov cfm.dwMask, CFM_ITALIC

	mov cfm.cbSize,60		;84 CHARFORMAT2 / 60 CHARFORMAT

	;Get the italic status.
	invoke SendMessage, hRichEditGlobal, EM_GETCHARFORMAT, TRUE, ADDR cfm

	;Toggle the italic effect
	xor cfm.dwEffects, CFE_ITALIC

	;Set the new italic status.
	invoke SendMessage, hRichEditGlobal, EM_SETCHARFORMAT, SCF_SELECTION, ADDR cfm
	.if eax == NULL
		invoke GetLastError
		mov nLastError,eax
		invoke FormatMessage,\
			FORMAT_MESSAGE_FROM_SYSTEM,\
			NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
		invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szAlignment,\
			MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
	.endif

	;Reset the dirty bit.
	invoke SendMessage, hRichEditGlobal, EM_SETMODIFY, TRUE, 0
	xor eax, eax
	ret
ItalicCmd endp

UnderlineCmd proc

	;Fill out the CHARFORMAT structure to set character effects.
	mov cfm.cbSize, sizeof cfm
	mov cfm.dwMask, CFM_UNDERLINE

	mov cfm.cbSize,60

	;Get the underline status.
	invoke SendMessage, hRichEditGlobal, EM_GETCHARFORMAT, TRUE, ADDR cfm

	;Toggle the underline effect
	xor cfm.dwEffects, CFE_UNDERLINE

	;Set the new underline status.
	invoke SendMessage, hRichEditGlobal, EM_SETCHARFORMAT, SCF_SELECTION, ADDR cfm

	;Reset the dirty bit.
	invoke SendMessage, hRichEditGlobal, EM_SETMODIFY, TRUE, 0
	xor eax, eax
	ret
UnderlineCmd endp

AlignCmd proc hWnd:HWND, iAlign:WORD

	;Fill out the PARAFORMAT structure with the mask and size .
	mov pf.cbSize, sizeof pf

	mov pf.cbSize, 156
	mov pf.dwMask, (PFM_ALIGNMENT)
	.IF iAlign == IDM_ALIGNRIGHT
		mov pf.wAlignment, PFA_RIGHT

		;uncheck left and center.
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNLEFT, (MF_BYCOMMAND or MF_UNCHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNLEFT, NULL
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNCENTER, (MF_BYCOMMAND or MF_UNCHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNCENTER, NULL

		;check align right
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNRIGHT, (MF_BYCOMMAND or MF_CHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNRIGHT, 1

	.ELSEIF iAlign == IDM_ALIGNLEFT
		mov pf.wAlignment, PFA_LEFT

		;uncheck right and center.
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNRIGHT, (MF_BYCOMMAND or MF_UNCHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNRIGHT, NULL
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNCENTER, (MF_BYCOMMAND or MF_UNCHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNCENTER, NULL

		;check align left
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNLEFT, (MF_BYCOMMAND or MF_CHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNLEFT, 1

	.ELSEIF iAlign == IDM_ALIGNCENTER
		mov pf.wAlignment, PFA_CENTER

		;uncheck right and left.
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNRIGHT, (MF_BYCOMMAND or MF_UNCHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNRIGHT, NULL
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNLEFT, (MF_BYCOMMAND or MF_UNCHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNLEFT, NULL

		;check align center
		invoke GetMenu, hWnd
		invoke CheckMenuItem, eax, IDM_ALIGNCENTER, (MF_BYCOMMAND or MF_CHECKED)
		invoke SendMessage, hToolBar, TB_CHECKBUTTON, IDM_ALIGNCENTER, 1

	.ENDIF
	;Set the new paragraph alignment.
	invoke SendMessage, hRichEditGlobal, EM_SETPARAFORMAT, 0, ADDR pf
	.if eax == NULL
		invoke GetLastError
		mov nLastError,eax
		invoke FormatMessage,\
			FORMAT_MESSAGE_FROM_SYSTEM,\
			NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
		invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szAlignment,\
			MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
	.endif

	;Reset the dirty bit. This message does not return a value!!
	invoke SendMessage, hRichEditGlobal, EM_SETMODIFY, TRUE, 0

	xor eax, eax
	ret
AlignCmd endp


ChooseFonts proc hWND:HWND
	invoke GetDC, hRichEditGlobal
	mov hDc, eax

	mov cf.lStructSize, sizeof CHOOSEFONT
	push hRichEditGlobal
	pop cf.hWndOwner 
	mov cf.Flags, (CF_TTONLY or CF_SCREENFONTS or CF_EFFECTS or CF_NOSCRIPTSEL)
	push offset myLogFont
	pop cf.lpLogFont
	mov cf.nSizeMin, 8
	mov cf.nSizeMax, 72
	mov cf.lpTemplateName, NULL
	mov cf.lpfnHook, NULL	

	invoke ChooseFont, ADDR cf
	.if eax == NULL
		invoke GetLastError
		mov nLastError,eax
		invoke FormatMessage,\
			FORMAT_MESSAGE_FROM_SYSTEM,\
			NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
		invoke MessageBoxEx, NULL, ADDR szChooseFont, NULL,\
			MB_OK+MB_ICONERROR, LANG_ENGLISH
	.else
		invoke CreateFontIndirect, cf.lpLogFont
		.if eax == NULL
			invoke GetLastError
			mov nLastError,eax
			invoke FormatMessage,\
				FORMAT_MESSAGE_FROM_SYSTEM,\
				NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
			invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szChooseFont,\
				MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		.endif

		invoke SelectObject, hDc, eax
		.if eax == NULL
			invoke GetLastError
			mov nLastError,eax
			invoke FormatMessage,\
				FORMAT_MESSAGE_FROM_SYSTEM,\
				NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
			invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szChooseFont,\
				MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		.endif
	
		invoke ReleaseDC, hRichEditGlobal, hDc

                       
		mov cfm.cbSize, sizeof cfm
		;mov cfm.dwMask, (CFM_ITALIC or CFM_BOLD or CFM_UNDERLINE)

		mov cfm.cbSize,60
		;invoke SendMessage, hRichEditGlobal, EM_GETCHARFORMAT, TRUE, ADDR cfm
		;.if eax == NULL
		;	invoke GetLastError
		;	mov nLastError,eax
		;	invoke FormatMessage,\
		;		FORMAT_MESSAGE_FROM_SYSTEM,\
		;		NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
		;	invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szEM_GTCHRFRMAT,\
		;		MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		;.endif

		;mov cfm.cbSize, 60
		or cfm.dwMask, (CFM_FACE or CFM_SIZE or\
			CFM_COLOR or CFM_UNDERLINE or CFM_BACKCOLOR)

		;Set the new typeface, preserving the previous effects.
		invoke lstrcpy, ADDR cfm.szFaceName, ADDR myLogFont.lfFaceName

		;Set the size: Multiply by 20 to convert to twips.
		xor edx, edx
		mov ebx, 20
		mov eax, myLogFont.lfHeight
		mul ebx
		mov cfm.yHeight, eax

		push cf.rgbColors
		pop cfm.crTextColor

		;is bold chosen?
		.if myLogFont.lfWeight == FW_BOLD
			or cfm.dwEffects, CFE_BOLD
		.else
			and cfm.dwEffects, 0FFFFFFFEh	;turn off the bold bit
		.endif

		;is italic chosen?
		mov ax,cf.nFontType
		and ax, 0200h
		.if ax == ITALIC_FONTTYPE
			or cfm.dwEffects, CFE_ITALIC
		.else
			and cfm.dwEffects, 0FFFFFFFDh	;turn off the italic bit
		.endif

		;is underline chosen?
		xor eax, eax
		mov al, myLogFont.lfUnderline
		.if eax == TRUE
			or cfm.dwEffects, CFE_UNDERLINE
		.else
			and cfm.dwEffects, 0FFFFFFFBh	;turn off the underline bit
		.endif

		invoke SendMessage, hRichEditGlobal, EM_SETCHARFORMAT, SCF_SELECTION,\
			 ADDR cfm
		.if eax == NULL
			invoke GetLastError
			mov nLastError,eax
			invoke FormatMessage,\
				FORMAT_MESSAGE_FROM_SYSTEM,\
				NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
			invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szSetCharFormat,\
				MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		.endif

		;make the push buttons sync
		mov ax,cf.nFontType
		and ax, 0200h
		.if ax == ITALIC_FONTTYPE
			.if bItalic == TRUE
			.else
			        invoke ToggleButton, hWndGlobal, IDM_ITALIC, bItalic
				mov bItalic, eax
			.endif
		.else
			.if bItalic == TRUE
			        invoke ToggleButton, hWndGlobal, IDM_ITALIC, bItalic
				mov bItalic, eax
			.endif
		.endif

		.if myLogFont.lfWeight == FW_BOLD
			.if bBold == TRUE
			.else
			        invoke ToggleButton, hWndGlobal, IDM_BOLD, bBold
				mov bBold, eax
			.endif
		.else
			.if bBold == TRUE
			        invoke ToggleButton, hWndGlobal, IDM_BOLD, bBold
				mov bBold, eax
			.endif
		.endif

		xor eax, eax
		mov al, myLogFont.lfUnderline
		.if eax == TRUE
			.if bUnderLine == TRUE
			.else
			        invoke ToggleButton, hWndGlobal, IDM_UNDERLINE, bUnderLine
				mov bUnderLine, eax
			.endif
		.else
			.if bUnderLine == TRUE
			        invoke ToggleButton, hWndGlobal, IDM_UNDERLINE, bUnderLine
				mov bUnderLine, eax
			.endif
		.endif

	.endif
	xor eax, eax
	ret
ChooseFonts endp

SaveTheFile proc nID:WORD
	LOCAL hFile:DWORD
	LOCAL of:OFSTRUCT
	LOCAL eStream:EDITSTREAM
	LOCAL iAttrib:DWORD

	.if nID == IDM_SAVETXT
		invoke lstrcpy, ADDR szFileName, ADDR szTxtFile
		mov iAttrib, SF_TEXT
	.else
		invoke lstrcpy, ADDR szFileName, ADDR szRtfFile
		mov iAttrib, SF_RTF
	.endif

	invoke OpenFile, ADDR szFileName, ADDR of, OF_CREATE
	.if eax != HFILE_ERROR
		mov hFile, eax
		mov eStream.dwCookie, eax
		mov eStream.dwError, 0
		mov eStream.pfnCallback, offset SaveCallback
		invoke SendMessage, hRichEditGlobal, EM_STREAMOUT, iAttrib, ADDR eStream
		.if eax == NULL
			invoke GetLastError
			mov nLastError,eax
			invoke FormatMessage,\
				FORMAT_MESSAGE_FROM_SYSTEM,\
				NULL, nLastError, NULL, ADDR szMsgBuff, 128, NULL
			invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szSaveFile,\
				MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		.endif
		invoke CloseHandle, hFile
		ret TRUE
	.else
		invoke MessageBoxEx, NULL, ADDR szMsgBuff, ADDR szSaveFile,\
			MB_OK+MB_ICONINFORMATION, LANG_ENGLISH
		ret FALSE
	.endif

SaveTheFile endp

SaveCallback proc dwCookie:DWORD, pbBuff:DWORD, cb:DWORD, pcb:DWORD
	invoke WriteFile, dwCookie, pbBuff, cb, pcb, NULL
	xor eax,eax
	ret
SaveCallback endp

About proc hDlg:HWND, dMsg:UINT, wParam:WPARAM, lParam:LPARAM
	mov eax, wParam
	.if dMsg == WM_INITDIALOG
		mov eax,1
		ret
	.elseif dMsg== WM_COMMAND              
		.if ax ==IDOK
			invoke EndDialog, hDlg, TRUE
			mov eax, 1
			;ret 
		.endif
	.else
		mov eax,0
		;ret  
	.endif
	ret
About endp

end Start
